View Issue Details

IDProjectCategoryView StatusLast Update
0014427LazarusIDEpublic2009-09-11 23:43
ReporterElphi Assigned ToMichael Van Canneyt  
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Fixed in Version0.9.29 (SVN) 
Summary0014427: Daemon - Interfaces missing in uses clause.
DescriptionBuilding a fresh daemon gives a lot of error messages starting with:
ys1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomImageList

Adding unit Interfaces to the program uses list solves this problem.

This should have been done automatically when the daemon was created as a new project.
TagsNo tags attached.
Fixed in Revision21646
LazTarget-
WidgetsetWin32/Win64
Attached Files

Activities

Elphi

2009-08-24 20:34

reporter   ~0030126

Forgot to refer to a patch: http://www.lazarus.freepascal.org/index.php/topic,7143.0.html

Michael Van Canneyt

2009-08-24 22:33

administrator   ~0030130

This is not correct. Interfaces should definitely NOT be part of a daemon application.
If you get an error, then the error is somewhere else.

Mattias Gaertner

2009-08-25 00:43

manager   ~0030131

Search if your program somewhere uses the LCL units Forms, Controls or Graphics. They require a graphical desktop.

Elphi

2009-08-25 00:53

reporter   ~0030132

Now I think of it indeed, if I look at the complete list of error messages below again, I have no doubt you're right. So the question is, why should those symbols be defined?

Found a related report: 0013606

Hint: Start of reading config file C:\lazarus\fpc\2.2.5\bin\i386-win32\fpc.cfg
Hint: End of reading config file C:\lazarus\fpc\2.2.5\bin\i386-win32\fpc.cfg
Free Pascal Compiler version 2.2.5 [2009/08/16] for i386
Copyright (c) 1993-2008 by Florian Klaempfl
Target OS: Win32 for i386
Compiling C:\DOCUME~1\motor\LOCALS~1\Temp\project1.lpr
Compiling daemonmapperunit1.pas
Compiling daemonunit1.pas
Compiling resource C:\DOCUME~1\motor\LOCALS~1\Temp\project1.rc
Compiling resource C:\DOCUME~1\motor\LOCALS~1\Temp\fpc-res.res
Linking C:\DOCUME~1\motor\LOCALS~1\Temp\project1.exe
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomImageList
project1.lpr(16,1) Error: Undefined symbol: WSRegisterMenuItem
project1.lpr(16,1) Error: Undefined symbol: WSRegisterMenu
project1.lpr(16,1) Error: Undefined symbol: WSRegisterMainMenu
project1.lpr(16,1) Error: Undefined symbol: WSRegisterPopupMenu
project1.lpr(16,1) Error: Undefined symbol: WSRegisterDragImageList
project1.lpr(16,1) Error: Undefined symbol: WSRegisterControl
project1.lpr(16,1) Error: Undefined symbol: WSRegisterWinControl
project1.lpr(16,1) Error: Undefined symbol: WSRegisterGraphicControl
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomControl
project1.lpr(16,1) Error: Undefined symbol: WSRegisterScrollingWinControl
project1.lpr(16,1) Error: Undefined symbol: WSRegisterScrollBox
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomFrame
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomForm
project1.lpr(16,1) Error: Undefined symbol: WSRegisterHintWindow
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomScrollBar
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomGroupBox
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomComboBox
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomListBox
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomEdit
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomMemo
project1.lpr(16,1) Error: Undefined symbol: WSRegisterButtonControl
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomButton
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomCheckBox
project1.lpr(16,1) Error: Undefined symbol: WSRegisterToggleBox
project1.lpr(16,1) Error: Undefined symbol: WSRegisterRadioButton
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomStaticText
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomLabel
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomPage
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomNotebook
project1.lpr(16,1) Error: Undefined symbol: WSRegisterShape
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomSplitter
project1.lpr(16,1) Error: Undefined symbol: WSRegisterPaintBox
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomImage
project1.lpr(16,1) Error: Undefined symbol: WSRegisterBevel
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomRadioGroup
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomCheckGroup
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomLabeledEdit
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomPanel
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomTrayIcon
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomBitBtn
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCustomSpeedButton
project1.lpr(16,1) Error: Undefined symbol: WSRegisterCommonDialog
project1.lpr(16,1) Error: Undefined symbol: WSRegisterFileDialog
project1.lpr(16,1) Error: Undefined symbol: WSRegisterOpenDialog
project1.lpr(16,1) Error: Undefined symbol: WSRegisterSaveDialog
project1.lpr(16,1) Error: Undefined symbol: WSRegisterSelectDirectoryDialog
project1.lpr(16,1) Error: Undefined symbol: WSRegisterColorDialog
project1.lpr(16,1) Error: Undefined symbol: WSRegisterColorButton
project1.lpr(16,1) Error: Undefined symbol: WSRegisterFontDialog
project1.lpr(16,1) Fatal: There were 50 errors compiling module, stopping

Mattias Gaertner

2009-08-25 01:26

manager   ~0030133

The symbols are defined in the LCL widgetset - the graphical backend.
The LCL has a few base units, that do not require the widgetset, but most do.
See the unit lcl/alllclunits.pp.

Vincent Snijders

2009-09-10 16:23

manager   ~0030600

I think this issue can be solved by removing the lazdeamon unit form the uses section of project1.lpr.

Issue History

Date Modified Username Field Change
2009-08-24 20:31 Elphi New Issue
2009-08-24 20:31 Elphi Widgetset => Win32/Win64
2009-08-24 20:34 Elphi Note Added: 0030126
2009-08-24 22:32 Michael Van Canneyt Status new => assigned
2009-08-24 22:32 Michael Van Canneyt Assigned To => Michael Van Canneyt
2009-08-24 22:33 Michael Van Canneyt Note Added: 0030130
2009-08-24 22:34 Michael Van Canneyt LazTarget => -
2009-08-24 22:34 Michael Van Canneyt Status assigned => feedback
2009-08-25 00:43 Mattias Gaertner Note Added: 0030131
2009-08-25 00:53 Elphi Note Added: 0030132
2009-08-25 01:26 Mattias Gaertner Note Added: 0030133
2009-09-10 16:23 Vincent Snijders Note Added: 0030600
2009-09-10 16:26 Vincent Snijders Fixed in Revision => 21646
2009-09-10 16:26 Vincent Snijders Status feedback => resolved
2009-09-10 16:26 Vincent Snijders Fixed in Version => 0.9.29 (SVN)
2009-09-10 16:26 Vincent Snijders Resolution open => fixed
2009-09-11 23:43 Elphi Status resolved => closed